#include <stdio.h>
#include <string.h>


int match(char *text, char *pattern)
{
  int i,lp,lt;
  
  lp=strlen(pattern);
  lt=strlen(text);
  for (i=0;i<lp;i++)
  {
    if (pattern[i]=='*')
      return 1;
    if (i>=lt)
      return 0;
    if (pattern[i]=='?')
      continue;
    if (pattern[i]!=text[i])
      return 0;
  }
  if (lt>lp)
    return 0;
  return 1;
}



int main(int argc, char *argv[])
{
  FILE *fin,*fout,*fjobout;
  char filename[256];
  char line[25],jobline[25],*l;
  char *name,*ext,*jobname,*jobext;
  int d;
  

  sprintf(filename,"%s/input",argv[1]);
  fin=fopen(filename,"rt");
  if (fin==NULL)
    return 2;
  sprintf(filename,"%s/output",argv[1]);
  fout=fopen(filename,"rt");
  if (fout==NULL)
    return 2;
  sprintf(filename,"%s/output",argv[2]);
  fjobout=fopen(filename,"rt");
  if (fjobout==NULL)
    return 2;

  fscanf(fin,"%d\n",&d);
  while (d--)
  {
    if (fgets(jobline,25,fjobout)==NULL)
      return 1;
    if ((l=index(jobline,'\n'))==NULL)
      return 1;
    l[0]=0;  
    if (fgets(line,25,fout)==NULL)
      return 2;
    if ((l=index(line,'\n'))==NULL)
      return 2;
    l[0]=0;  
    if (!strcmp(line,"IMPOSSIBLE") && strcmp(line,jobline))
      { printf("%d - line 65\n",d); return 1;}
    if (strcmp(line,"IMPOSSIBLE") && !strcmp("IMPOSSIBLE",jobline))
      { printf("%d - line 67\n",d); return 1;}
    if (strcmp(jobline,"IMPOSSIBLE") && strncmp(jobline,"DEL ",4))
      { printf("%d - line 69\n",d); return 1;}

    if (strcmp(jobline,"IMPOSSIBLE"))
    {
      jobext=index(jobline+4,'.');
      if (jobext==NULL)
        { printf("%d - line 75\n",d); return 1;}
      jobext[0]=0;
      jobext++;
      jobname=jobline+4;
    }  

    while (1)
    {
      if (fgets(line,25,fin)==NULL)
        return 2;
      if ((l=index(line,'\n'))==NULL)
        return 2;
      l[0]=0;  
      if (!strcmp(line,""))
        break;
      if (!strcmp(jobline,"IMPOSSIBLE"))
        continue;
      
      ext=index(line,'.');
      if (ext==NULL)
        ext=line+strlen(line);
      else
      {
        ext[0]=0;
        ext++;
      }  
      name=line+1;
      
      
      if (match(name,jobname) && match(ext,jobext))
      {
        if (line[0]=='+')
          { printf("%d - line 107\n",d); return 1;}
      } else
      {
        if (line[0]=='-')
          { printf("%d - line 111\n",d); return 1;}
      }
    }
  }
  
  return 0;
}

